# not build kwin ext with kwin >= 5.25
%global kwin_ext 0

Name:           dde-kwin
Version:        5.5.24
Release:        1
Summary:        KWin configuration for Deepin Desktop Environment
License:        GPLv3+
URL:            https://github.com/linuxdeepin/%{name}
Source0:        %{name}-%{version}.tar.gz
%if !%{kwin_ext}
%global debug_package %{nil}
%endif

Patch0001:      0001-dde-kwin-support-QFont.patch
Patch0002:      0002-feat-close-judge-XDG_SESSION_TYPE.patch


BuildRequires:  gcc-c++
BuildRequires:  cmake
BuildRequires:  extra-cmake-modules >= 5.54
BuildRequires:  gdb
BuildRequires:  kwin-devel
BuildRequires:  kwayland-server-devel
BuildRequires:  pkgconfig(Qt5X11Extras)
BuildRequires:  pkgconfig(Qt5Qml)
BuildRequires:  gsettings-qt-devel
BuildRequires:  libepoxy-devel
BuildRequires:  dtkgui-devel
BuildRequires:  dtkcore-devel
BuildRequires:  kf5-kwayland-devel
BuildRequires:  kf5-kglobalaccel-devel
BuildRequires:  cmake(KDecoration2)
BuildRequires:  cmake(KF5I18n)
BuildRequires:  qt5-linguist
BuildRequires:  kf5-kdeclarative-devel
BuildRequires:  kf5-kservice-devel
BuildRequires:  kf5-plasma-devel
BuildRequires:  kdecoration-devel
BuildRequires:  kf5-ktextwidgets-devel
BuildRequires:  qt5-qtdeclarative-devel

%if %{kwin_ext}
# for libQt5EdidSupport.a
BuildRequires:  qt5-qtbase-static
BuildRequires:  qt5-qtbase-private-devel
%{?_qt5:Requires: %{_qt5}%{?_isa} = %{_qt5_version}}
Requires:       dde-qt5integration%{?_isa}
Requires:       kwin%{?_isa} >= 5.21
%else
Requires:       %{_bindir}/kwin_x11
%endif

# since F31
Obsoletes:      deepin-wm <= 1.9.38
Obsoletes:      deepin-wm-switcher <= 1.1.9
Obsoletes:      deepin-metacity <= 3.22.24
Obsoletes:      deepin-metacity-devel <= 3.22.24
Obsoletes:      deepin-mutter <= 3.20.38
Obsoletes:      deepin-mutter-devel <= 3.20.38

Requires:       kf5-kconfig-core
Requires:       kf5-kcoreaddons
Requires:       kf5-kglobalaccel-libs
Requires:       kf5-ki18n
Requires:       kf5-kwindowsystem
Requires:       kdecoration

%description
This package provides a kwin configuration that used as the new WM for Deepin
Desktop Environment.

%if %{kwin_ext}
%package devel
Summary:        Development package for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       kwin-devel%{?_isa}
Requires:       qt5-qtx11extras-devel%{?_isa}
Requires:       gsettings-qt-devel%{?_isa}
Requires:       dtkcore-devel%{?_isa}
Requires:       kf5-kglobalaccel-devel%{?_isa}
Requires:       deepin-desktop-server

%description devel
Header files and libraries for %{sname}.
%endif

%prep
%autosetup -p1 -n %{name}-%{version}
sed -i 's:/lib/:%{_lib}/:' plugins/platforms/lib/CMakeLists.txt
sed -i 's:/lib/:/%{_lib}/:' plugins/platforms/plugin/main.cpp \
                            plugins/platforms/plugin/main_wayland.cpp
sed -i 's:/usr/lib:%{_libexecdir}:' deepin-wm-dbus/deepinwmfaker.cpp
sed -i 's/kwin 5.21.5/kwin 5.24.4/' configures/kwin_no_scale.in

%build
# help find (and prefer) qt5 utilities, e.g. qmake, lrelease
export PATH=%{_qt5_bindir}:$PATH
%cmake  -DCMAKE_INSTALL_PREFIX=%{_prefix} \
        -DCMAKE_INSTALL_LIBDIR=%{_libdir} \
        -DCMAKE_BUILD_TYPE=RelWithDebInfo \
        -DUSE_WINDOW_TOOL=OFF \
        -DENABLE_BUILTIN_BLUR=OFF \
        -DENABLE_KDECORATION=ON \
        -DENABLE_BUILTIN_MULTITASKING=OFF \
        -DENABLE_BUILTIN_BLACK_SCREEN=OFF \
        -DUSE_DEEPIN_WAYLAND=OFF \
%if !%{kwin_ext}
        -DUSE_PLUGINS=OFF
%endif

%make_build

%install
%make_install
chmod 755 %{buildroot}%{_bindir}/kwin_no_scale

%files
%doc CHANGELOG.md
%license LICENSE
%{_sysconfdir}/xdg/*
%{_bindir}/kwin_no_scale
%{_bindir}/deepin-wm-dbus
%{_datadir}/dbus-1/services/*.service
%{_datadir}/dbus-1/interfaces/*.xml
%{_datadir}/kwin/scripts/*
%{_datadir}/kwin/tabbox/*
%{_datadir}/dsg/
%if %{kwin_ext}
%{_qt5_plugindir}/org.kde.kdecoration2/libdeepin-chameleon.so
%{_qt5_plugindir}/platforms/lib%{name}-xcb.so
%{_qt5_plugindir}/platforms/lib%{name}-wayland.so
%{_qt5_plugindir}/kwin/effects/plugins/
%{_datadir}/dde-kwin-xcb/
%{_libdir}/libkwin-xcb.so.0
%{_libdir}/libkwin-xcb.so.0.*

%files devel
%{_libdir}/libkwin-xcb.so
%{_libdir}/pkgconfig/%{name}.pc
%{_includedir}/%{name}
%endif

%changelog
* Tue Aug 01 2023 leeffo <liweiganga@uniontech.com> - 5.5.24-1
- upgrade to version 5.5.24

* Tue Jun 13 2023 liweigang <liweiganga@uniontech.com> - 5.4.26-4
- add deepin-wm-dbus

* Wed Aug 03 2022 liweiganga <liweiganga@uniontech.com> - 5.4.26-3
- modify kwin_no_scale permission to 755

* Tue Aug 02 2022 liweiganga <liweiganga@uniontech.com> - 5.4.26-2
- modify requires

* Mon Jul 25 2022 konglidong <konglidong@uniontech.com> - 5.4.26-1
- update to 5.4.26

* Mon Feb 21 2022 liweigang <liweiganga@uniontech.com> - 5.1.0.27-2
- fix copmile error

* Thu Jul 08 2021 weidong <weidong@uniontech.com> - 5.1.0.27-1
- Update 5.1.0.27

* Thu Jul 30 2020 openEuler Buildteam <buildteam@openeuler.org> - 5.0.13+c1-6
- Package init
